import threading
from my_tensorrt_code import TRTInference, trt

exitFlag = 0


class myThread(threading.Thread):
    def __init__(self, func, args):
        threading.Thread.__init__(self)
        self.func = func
        self.args = args

    def run(self):
        print("Starting " + self.args[0])
        self.func(*self.args)
        print("Exiting " + self.args[0])


if __name__ == '__main__':
    # Create new threads
    '''
    format thread:
        - func: function names, function that we wished to use
        - arguments: arguments that will be used for the func's arguments
    '''

    trt_engine_path = 'mnist.trt'

    max_batch_size = 1
    trt_inference_wrapper1 = TRTInference(trt_engine_path,
                                         trt_engine_datatype=trt.DataType.FLOAT,
                                         batch_size=max_batch_size)
    trt_inference_wrapper2 = TRTInference(trt_engine_path,
                                          trt_engine_datatype=trt.DataType.FLOAT,
                                          batch_size=max_batch_size)

    # Get TensorRT SSD model output
    input_img_path1 = 'pgms/3.pgm'
    input_img_path2 = 'pgms/1.pgm'

    thread1 = myThread(trt_inference_wrapper1.infer, [input_img_path1])
    thread2 = myThread(trt_inference_wrapper2.infer, [input_img_path2])

    # Start new Threads
    thread1.start()
    thread2.start()
    thread1.join()
    thread2.join()
    trt_inference_wrapper1.destory()
    trt_inference_wrapper2.destory()
    print("Exiting Main Thread")
